"""
Adapts the template textproto file to the specified app.
It adjusts the path, package and MainActivity according to the specified app.

A template file with placeholders is used, so that the file can be adapted to any app.
To not change the template file, a copy of the template file is created and the placeholders are replaced with the
specified app's information. The copy is then used for the run of the reinforcement learner.
"""
import re


def update_textproto(new_apk_path, new_package_name, new_main_activity):
    with open('/home/coder/workspace/Testplattform/ReinforcementTest/custom_app_template.textproto', 'r') as file:
        textproto_content = file.read()

    # Replace the path with the correct apk path
    textproto_content = re.sub('PATH_PLACEHOLDER', new_apk_path, textproto_content)

    # Replace the package name and the main activity with the ones from the apk
    textproto_content = re.sub('PACKAGE_PLACEHOLDER', new_package_name, textproto_content)
    textproto_content = re.sub('ACTIVITY_PLACEHOLDER', new_main_activity, textproto_content)

    # Save the changes
    with open('/home/coder/workspace/Testplattform/ReinforcementTest/custom_app.textproto', 'w') as file:
        file.write(textproto_content)
